Index: python/job.temp
===================================================================
--- python/job.temp	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
+++ python/job.temp	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -33,7 +33,5 @@
   module load grib_api/1.14.5
   module load emos/437-r64
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
-  export PATH=${PATH}:${HOME}/ECMWFDATA7.1/python
+  export PATH=${PATH}:${HOME}/flex_extract_v7.1/python
   ;;
   *cca*)
@@ -43,15 +41,6 @@
   module load python
   export SCRATCH=$TMPDIR
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
-  export PATH=${PATH}:${HOME}/ECMWFDATA7.1/python
+  export PATH=${PATH}:${HOME}/flex_extract_v7.1/python
   ;;
-#  *)
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PATH=/opt/anaconda/bin:$ECMWFDATA/python:${PATH}
-#  export PYTHONPATH=/opt/anaconda/lib/python2.7/site-packages/grib_api:$ECMWFDATA/python
-#  export SCRATCH=$ECMWFDATA/python
-#  which python
-#  ;;
 esac
 
@@ -63,8 +52,4 @@
 
 cat >$CONTROL<<EOF
-GATEWAY srvx8.img.univie.ac.at
-DESTINATION annep@genericSftp
-EOF
-cat >>$CONTROL<<EOF
 EOF
 
Index: python/job.temp.o
===================================================================
--- python/job.temp.o	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/job.temp.o	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -33,6 +33,4 @@
   module load grib_api/1.14.5
   module load emos/437-r64
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
   export PATH=${PATH}:
   ;;
@@ -43,15 +41,6 @@
   module load python
   export SCRATCH=$TMPDIR
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
   export PATH=${PATH}:
   ;;
-#  *)
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PATH=/opt/anaconda/bin:$ECMWFDATA/python:${PATH}
-#  export PYTHONPATH=/opt/anaconda/lib/python2.7/site-packages/grib_api:$ECMWFDATA/python
-#  export SCRATCH=$ECMWFDATA/python
-#  which python
-#  ;;
 esac
 
@@ -62,5 +51,5 @@
 export CONTROL=CONTROL
 
-cat >>$CONTROL<<EOF
+cat >$CONTROL<<EOF
 EOF
 
Index: python/joboper.ksh
===================================================================
--- python/joboper.ksh	(revision ccab8091e3f70844b2b6e73b9aa5e6b41aaf5ff5)
+++ python/joboper.ksh	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -33,7 +33,5 @@
   module load grib_api/1.14.5
   module load emos/437-r64
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
-  export PATH=${PATH}:${HOME}/ECMWFDATA7.1/python
+  export PATH=${PATH}:${HOME}/flex_extract_v7.1/python
   ;;
   *cca*)
@@ -43,15 +41,6 @@
   module load python
   export SCRATCH=$TMPDIR
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PYTHONPATH=$ECMWFDATA/python
-  export PATH=${PATH}:${HOME}/ECMWFDATA7.1/python
+  export PATH=${PATH}:${HOME}/flex_extract_v7.1/python
   ;;
-#  *)
-#  export ECMWFDATA=$HOME/ECMWFDATA$VERSION
-#  export PATH=/opt/anaconda/bin:$ECMWFDATA/python:${PATH}
-#  export PYTHONPATH=/opt/anaconda/lib/python2.7/site-packages/grib_api:$ECMWFDATA/python
-#  export SCRATCH=$ECMWFDATA/python
-#  which python
-#  ;;
 esac
 
@@ -67,28 +56,38 @@
 accuracy 16
 addpar 186 187 188 235 139 39 
+area 
+base_time ${MSJ_BASETIME}
 basetime None
+controlfile CONTROL.temp
 cwc 0
 date_chunk 3
 debug 1
+destination None
 dpdeta 1
 dtime 3
 ecfsdir ectmp:/${USER}/econdemand/
+ecgid None
 ecstorage 0
 ectrans 1
-start_date ${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}
+ecuid None
+end_date ${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}
 eta 0
 etadiff 0
+etapar 77
 expver 1
 format GRIB1
+gateway None
 gauss 1
 grib2flexpart 0
 grid 5000
 inputdir ../work
+install_target None
+job_template job.temp
 left -15000
 level 60
 levelist 55/to/60
 lower 30000
-mailfail ${USER}
-mailops ${USER}
+mailfail ${USER} 
+mailops ${USER} 
 makefile None
 marsclass EI
@@ -99,4 +98,5 @@
 outputdir ../work
 prefix EI
+queue ecgate
 resol 63
 right 45000
@@ -108,4 +108,5 @@
 type AN FC FC FC FC FC AN FC FC FC FC FC AN FC FC FC FC FC AN FC FC FC FC FC 
 upper 75000
+wrf 0
 EOF
 
Index: python/mk_install_tar.sh
===================================================================
--- python/mk_install_tar.sh	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
+++ python/mk_install_tar.sh	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -0,0 +1,15 @@
+#!/bin/bash
+#
+# @Author: Anne Philipp
+#
+# @Date: June, 7 2018
+#
+# @Description: Makes a tarball for installation
+#
+
+tarname='flex_extract_v7.1.tar.gz'
+path='/nas/tmc/Anne/Interpolation/flexextract/flexextract/python/../'
+
+tar -cvf $tarname ${path}python/*py ${path}python/CONTROL* ${path}python/*ksh ${path}python/*temp ${path}python/ECMWF_ENV ${path}python/*json ${path}grib_templates ${path}src/*.f ${path}src/*.f90 ${path}src/*.h ${path}src/Makefile*  
+
+
Index: python/plot_retrieved.py
===================================================================
--- python/plot_retrieved.py	(revision ff99eae65dfaeec1221e06572d770ebd48feb3f4)
+++ python/plot_retrieved.py	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -1,10 +1,4 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
-#************************************************************************
-# ToDo AP
-# - documentation der Funktionen
-# - docu der progam functionality
-# - apply pep8
-#************************************************************************
 #*******************************************************************************
 # @Author: Leopold Haimberger (University of Vienna)
@@ -34,4 +28,5 @@
 #    - main
 #    - get_basics
+#    - get_files_per_date
 #    - plot_retrieved
 #    - plot_timeseries
@@ -219,6 +214,5 @@
     c.area = np.asarray(c.area)
 
-    files = UioFiles(c.prefix+'*')
-    files.list_files(c.inputdir)
+    files = UioFiles(c.inputdir, c.prefix+'*')
     ifiles = get_files_per_date(files.files, datelist)
     ifiles.sort()
@@ -622,5 +616,5 @@
                         help="FLEXPART root directory (to find \
                         'grib2flexpart and COMMAND file)\n \
-                        Normally ECMWFDATA resides in the scripts directory \
+                        Normally flex_extract resides in the scripts directory \
                         of the FLEXPART distribution")
 
Index: python/prepare_flexpart.py
===================================================================
--- python/prepare_flexpart.py	(revision None)
+++ python/prepare_flexpart.py	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -1,9 +1,4 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
-#************************************************************************
-# ToDo AP
-# - wieso start=startm1 wenn basetime = 0 ?  wenn die fluxes nicht mehr
-#   relevant sind? verstehe ich nicht
-#************************************************************************
 #*******************************************************************************
 # @Author: Anne Fouilloux (University of Oslo)
@@ -62,8 +57,9 @@
 import sys
 import socket
+import _config
 
 # software specific classes and modules from flex_extract
 from UioFiles import UioFiles
-from tools import interpret_args_and_control, clean_up
+from tools import clean_up, get_cmdline_arguments, read_ecenv
 from EcFlexpart import EcFlexpart
 
@@ -81,4 +77,5 @@
     sys.path.append(LOCAL_PYTHON_PATH)
 
+
 # ------------------------------------------------------------------------------
 # FUNCTION
@@ -97,10 +94,28 @@
         <nothing>
     '''
-    args, c = interpret_args_and_control()
-    prepare_flexpart(args, c)
+
+    args = get_cmdline_arguments()
+
+    try:
+        c = ControlFile(args.controlfile)
+    except IOError:
+        try:
+            c = ControlFile(LOCAL_PYTHON_PATH + args.controlfile)
+        except IOError:
+            print 'Could not read CONTROL file "' + args.controlfile + '"'
+            print 'Either it does not exist or its syntax is wrong.'
+            print 'Try "' + sys.argv[0].split('/')[-1] + \
+                  ' -h" to print usage information'
+            sys.exit(1)
+
+    env_parameter = read_ecenv(c.ecmwfdatadir + 'python/ECMWF_ENV')
+    c.assign_args_to_control(args, env_parameter)
+    c.assign_envs_to_control(env_parameter)
+    c.check_conditions()
+    prepare_flexpart(args.ppid, c)
 
     return
 
-def prepare_flexpart(args, c):
+def prepare_flexpart(ppid, c):
     '''
     @Description:
@@ -112,6 +127,7 @@
 
     @Input:
-        args: instance of ArgumentParser
-            Contains the commandline arguments from script/program call.
+        ppid: int
+            Contains the ppid number of the current ECMWF job. If it is called
+            from this script, it is "None".
 
         c: instance of class ControlFile
@@ -132,8 +148,8 @@
     '''
 
-    if not args.ppid:
+    if not ppid:
         c.ppid = str(os.getppid())
     else:
-        c.ppid = args.ppid
+        c.ppid = ppid
 
     c.ecapi = ecapi
@@ -148,17 +164,19 @@
                         day=int(c.end_date[6:]))
 
-    # to deaccumulate the fluxes correctly
-    # one day ahead of the start date and
-    # one day after the end date is needed
-    startm1 = start - datetime.timedelta(days=1)
-#    endp1 = end + datetime.timedelta(days=1)
-
-    # get all files with flux data to be deaccumulated
-    inputfiles = UioFiles('*OG_acc_SL*.' + c.ppid + '.*')
-    inputfiles.list_files(c.inputdir)
+    # assign starting date minus 1 day
+    # since for basetime 00 we need the 12 hours upfront
+    # (the day before from 12 UTC to current day 00 UTC)
+    if c.basetime == '00':
+        start = start - datetime.timedelta(days=1)
+
+    print 'Prepare ' + start.strftime("%Y%m%d") + \
+           "/to/" + end.strftime("%Y%m%d")
 
     # create output dir if necessary
     if not os.path.exists(c.outputdir):
         os.makedirs(c.outputdir)
+
+    # get all files with flux data to be deaccumulated
+    inputfiles = UioFiles(c.inputdir, '*OG_acc_SL*.' + c.ppid + '.*')
 
     # deaccumulate the flux data
@@ -167,17 +185,9 @@
     flexpart.deacc_fluxes(inputfiles, c)
 
-    print 'Prepare ' + start.strftime("%Y%m%d") + \
-          "/to/" + end.strftime("%Y%m%d")
-
     # get a list of all files from the root inputdir
-    inputfiles = UioFiles('????__??.*' + c.ppid + '.*')
-    inputfiles.list_files(c.inputdir)
-
-    # produce FLEXPART-ready GRIB files and
-    # process GRIB files -
+    inputfiles = UioFiles(c.inputdir, '????__??.*' + c.ppid + '.*')
+
+    # produce FLEXPART-ready GRIB files and process them -
     # copy/transfer/interpolate them or make them GRIB2
-    if c.basetime == '00':
-        start = startm1
-
     flexpart = EcFlexpart(c, fluxes=False)
     flexpart.create(inputfiles, c)
@@ -187,5 +197,5 @@
     # otherwise delete temporary files
     if int(c.debug) != 0:
-        print 'Temporary files left intact'
+        print '\nTemporary files left intact'
     else:
         clean_up(c)
Index: python/profiling.py
===================================================================
--- python/profiling.py	(revision ff99eae65dfaeec1221e06572d770ebd48feb3f4)
+++ python/profiling.py	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -3,5 +3,5 @@
 #************************************************************************
 # ToDo AP
-# - check of license of book content
+# - check license of book content
 #************************************************************************
 #*******************************************************************************
Index: python/submit.py
===================================================================
--- python/submit.py	(revision ff99eae65dfaeec1221e06572d770ebd48feb3f4)
+++ python/submit.py	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -44,15 +44,13 @@
 import subprocess
 import inspect
+import collections
 
 # software specific classes and modules from flex_extract
-from tools import interpret_args_and_control, normal_exit
+import _config
+from tools import normal_exit, get_cmdline_arguments, submit_job_to_ecserver, \
+                  read_ecenv
 from get_mars_data import get_mars_data
 from prepare_flexpart import prepare_flexpart
-
-# add path to pythonpath so that python finds its buddies
-LOCAL_PYTHON_PATH = os.path.dirname(os.path.abspath(
-    inspect.getfile(inspect.currentframe())))
-if LOCAL_PYTHON_PATH not in sys.path:
-    sys.path.append(LOCAL_PYTHON_PATH)
+from ControlFile import ControlFile
 
 # ------------------------------------------------------------------------------
@@ -76,7 +74,26 @@
 
     called_from_dir = os.getcwd()
-    args, c = interpret_args_and_control()
+
+    args = get_cmdline_arguments()
+
+    try:
+        c = ControlFile(args.controlfile)
+    except IOError:
+        try:
+            c = ControlFile(LOCAL_PYTHON_PATH + args.controlfile)
+        except IOError:
+            print 'Could not read CONTROL file "' + args.controlfile + '"'
+            print 'Either it does not exist or its syntax is wrong.'
+            print 'Try "' + sys.argv[0].split('/')[-1] + \
+                  ' -h" to print usage information'
+            sys.exit(1)
+
+    env_parameter = read_ecenv(c.ecmwfdatadir + 'python/ECMWF_ENV')
+    c.assign_args_to_control(args)
+    c.assign_envs_to_control(env_parameter)
+    c.check_conditions()
 
     # on local side
+    # on ECMWF server this would be the local side
     if args.queue is None:
         if c.inputdir[0] != '/':
@@ -84,7 +101,7 @@
         if c.outputdir[0] != '/':
             c.outputdir = os.path.join(called_from_dir, c.outputdir)
-        get_mars_data(args, c)
-        prepare_flexpart(args, c)
-        normal_exit(c)
+        get_mars_data(c)
+        prepare_flexpart(args.ppid, c)
+        normal_exit(c.mailfail, 'Done!')
     # on ECMWF server
     else:
@@ -125,48 +142,52 @@
     '''
 
-    # read template file and split from newline signs
+    # read template file and get index for CONTROL input
     with open(jtemplate) as f:
         lftext = f.read().split('\n')
-        insert_point = lftext.index('EOF')
+    insert_point = lftext.index('EOF')
 
-    # put all parameters of ControlFile instance into a list
-    clist = c.to_list() # ondemand
-    colist = []  # operational
-    mt = 0
+    if not c.basetime:
+    # --------- create on demand job script ------------------------------------
+        if c.maxstep > 24:
+            print '---- Pure forecast mode! ----'
+        else:
+            print '---- On-demand mode! ----'
+        job_file = jtemplate[:-4] + 'ksh'
+        clist = c.to_list()
 
-    for elem in clist:
-        if 'maxstep' in elem:
-            mt = int(elem.split(' ')[1])
+        lftextondemand = lftext[:insert_point] + clist + lftext[insert_point:]
 
-    for elem in clist:
-        if 'start_date' in elem:
-            elem = 'start_date ' + '${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}'
-        if 'end_date' in elem:
-            elem = 'end_date ' + '${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}'
-        if 'base_time' in elem:
-            elem = 'base_time ' + '${MSJ_BASETIME}'
-        if 'time' in elem and mt > 24:
-            elem = 'time ' + '${MSJ_BASETIME} {MSJ_BASETIME}'
-        colist.append(elem)
+        with open(job_file, 'w') as f:
+            f.write('\n'.join(lftextondemand))
 
-    lftextondemand = lftext[:insert_point] + clist + lftext[insert_point + 2:]
-    lftextoper = lftext[:insert_point] + colist + lftext[insert_point + 2:]
+        submit_job_to_ecserver('', queue, job_file)
 
-    with open('job.ksh', 'w') as h:
-        h.write('\n'.join(lftextondemand))
+    else:
+    # --------- create operational job script ----------------------------------
+        print '---- Operational mode! ----'
+        job_file = jtemplate[:-5] + 'oper.ksh'
+        #colist = []
 
-    with open('joboper.ksh', 'w') as h:
-        h.write('\n'.join(lftextoper))
+        if c.maxstep:
+            mt = int(c.maxstep)
+        else:
+            mt = 0
 
-    # submit job script to queue
-    try:
-        p = subprocess.check_call(['ecaccess-job-submit', '-queueName',
-                                   queue, 'job.ksh'])
-    except subprocess.CalledProcessError as e:
-        print 'ecaccess-job-submit failed!'
-        print 'Error Message: '
-        print e.output
-        exit(1)
+        c.start_date = '${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}'
+        c.end_date = '${MSJ_YEAR}${MSJ_MONTH}${MSJ_DAY}'
+        c.base_time = '${MSJ_BASETIME}'
+        if mt > 24:
+            c.time = '${MSJ_BASETIME} {MSJ_BASETIME}'
 
+        colist = c.to_list()
+
+        lftextoper = lftext[:insert_point] + colist + lftext[insert_point + 2:]
+
+        with open(job_file, 'w') as f:
+            f.write('\n'.join(lftextoper))
+
+        submit_job_to_ecserver('', queue, job_file)
+
+    # --------------------------------------------------------------------------
     print 'You should get an email with subject flex.hostname.pid'
 
Index: python/test_suite.py
===================================================================
--- python/test_suite.py	(revision None)
+++ python/test_suite.py	(revision 54a8a01d975ad8c2dea60c93439d9bc0ef426132)
@@ -1,10 +1,4 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
-#************************************************************************
-# ToDo AP
-# - provide more tests
-# - provide more documentation
-#************************************************************************
-
 #*******************************************************************************
 # @Author: Leopold Haimberger (University of Vienna)
@@ -25,5 +19,5 @@
 #
 # @Program Functionality:
-#    This script triggers the ECMWFDATA test suite. Call with
+#    This script triggers the flex_extract test suite. Call with
 #    test_suite.py [test group]
 #
